#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <signal.h>

#define BUFSIZE 32768
#define FORKON 8192
#define VERSION "v.0.0.1"

#define PDEBUG 0


unsigned char ret_buf[BUFSIZE];
char * error_return = "<HTML>\n<BODY><p>File not found\n</BODY>\n</HTML>";
FILE *logfile;

int logflag=0;
int DEBUG=0;
int MYPORT=8000;    /* the port users will be connecting to */
time_t tempo;

char *mytime(struct tm *src)
{
  char *str;
  char day[4];
  char mon[4];

                      /*
	              struct tm {
                      int     tm_sec;          seconds 
                      int     tm_min;          minutes
                      int     tm_hour;         hours 
                      int     tm_mday;         day of the month 
                      int     tm_mon;          month 
                      int     tm_year;         year 
                      int     tm_wday;         day of the week 
                      int     tm_yday;         day in the year 
                      int     tm_isdst;        daylight saving time 
		      };*/

  if(PDEBUG) printf("Entrato in mytime()\n");
  switch(src->tm_wday)
    {
    case 0:
      strcpy(day,"Sun");
      break;
    case 1:
      strcpy(day,"Mon");
      break;
    case 2:
      strcpy(day,"Tue");
      break;
    case 3:
      strcpy(day,"Wed");
      break;
    case 4:
      strcpy(day,"Thu");
      break;
    case 5:
      strcpy(day,"Fri");
      break;
    case 6:
      strcpy(day,"Sat");
      break;
    }

  switch(src->tm_mon)
    {
    case 0:
      strcpy(mon,"Jan");
      break;
    case 1:
      strcpy(mon,"Feb");
      break;
    case 2:
      strcpy(mon,"Mar");
      break;
    case 3:
      strcpy(mon,"Apr");
      break;
    case 4:
      strcpy(mon,"May");
      break;
    case 5:
      strcpy(mon,"Jun");
      break;
    case 6:
      strcpy(mon,"Jul");
      break;
    case 7:
      strcpy(mon,"Aug");
      break;
    case 8:
      strcpy(mon,"Sep");
      break;
    case 9:
      strcpy(mon,"Oct");
      break;
    case 10:
      strcpy(mon,"Nov");
      break;
    case 11:
      strcpy(mon,"Dec");
      break;
    }

  str=malloc(30);
  sprintf(str,"%s %s %02d %02d:%02d:%02d %d%c",day,mon,src->tm_mday,src->tm_hour,src->tm_min,src->tm_sec,1900+src->tm_year,'\0');
  return str;
}

void nop()
{
}

void read_file(char * buf, int num_buf,int *sock)
{
  int i,j,totalBytes,bytesSent,totalSent,size,times;
  char *cp, *cp2;
  FILE *f;

  if(PDEBUG) printf("Entrato in read_file()\n");

  cp=buf+5;
  cp2=strstr(cp," HTTP");
  if(cp2!=NULL) *cp2='\0';
  if(DEBUG) printf("file: |%s|\n",cp);

  if(logflag)
    { 
      time(&tempo);
      fprintf(logfile,"%s file: |%s|\n",mytime(localtime(&tempo)),cp);
    }

  if(!strcmp(cp,""))
    {  
      (f=fopen("index.htm","r"))||(f=fopen("index.html","r"));
      if(DEBUG) printf("invio pagina di default\n");
      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s invio pagina di default\n",mytime(localtime(&tempo)));
	}
    }
  else f=fopen(cp,"r");

  if(f==NULL) 
    {
      bytesSent=send(*sock,error_return,strlen(error_return),0);
      return;
    }

  if(strstr(cp,".mp3")||strstr(cp,".MP3"))
  {
    bytesSent=send(*sock,"ICY 200 OK",strlen("ICY 200 OK"),0);
    bytesSent=send(*sock,"icy-metaint:?????",strlen("icy-metaint:?????"),0);
  } 

  for(j=0;j<BUFSIZE;j++)ret_buf[j]='\0';
  totalBytes=0;
  times=0;

  while(!feof(f))
    { 
      times++;
      i=fread(ret_buf,1,BUFSIZE,f);
      if(DEBUG) printf("[%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",times,getpid(),i);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s [%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",mytime(localtime(&tempo)),times,getpid(),i);	  
	  if(times%10==0) fflush(logfile);
	}

      if(i==0) 
	{
	  fclose(f); 
	  bytesSent=send(*sock,error_return,strlen(error_return),0); 
	  return;
	}
      size=i;
      totalSent=0;
      do
	{
	  bytesSent=send(*sock,ret_buf+totalSent,i-=totalSent,0);
	  if(bytesSent==-1) {fclose(f);return;}
	  totalSent+=bytesSent;
	}while(totalSent<size);
      totalBytes+=totalSent;
    }
  if(DEBUG) printf("%d bytes read from file %s,in %d times\n",totalBytes,cp,times);
  if(logflag) 
    {
      time(&tempo);
      fprintf(logfile,"%s %d bytes read from file %s,in %d times\n",mytime(localtime(&tempo)),totalBytes,cp,times);
      fflush(logfile);
    }
  fclose(f);
}

int shallIfork(char* filename)
{
  int i;
  char buf[FORKON+1];
  FILE *f;

    if(PDEBUG) printf("Entrato in shallIfork()\n");

  f=fopen(filename,"r");
  if(f==NULL) return 0;
  if((i=fread(buf,1,FORKON+1,f))==FORKON+1) return 1;
  return 0;
}

char* nomefile(char *buf)
{
  char *cp, *cp2;

    if(PDEBUG) printf("Entrato in nomefile()\n");

  cp=buf+5;
  cp2=strstr(cp," HTTP");
  if(cp2!=NULL) *cp2='\0';
  return cp;
}

int main(int argc, char *argv[],char *envp[])
{
  int i,j,totalReceived;
  char recvBuffer[BUFSIZE];
  int sock,tmp_porta;
  int serverSocket;
  struct sockaddr_in serverAddr;
  struct sockaddr_in clientAddr;
  int clientAddrSize;
  struct hostent* entity;
  struct sigaction sa_dontcare;
  int childPID,stop;
  int stato;
  char *str_porta;

  for(j=1;j<argc;j++)
    {
      if(!strcmp(argv[j],"-log"))
	{ 
	  logflag=1;
	  logfile=fopen("logfile.log","a+");
	  if(logfile==NULL) logflag=0;
	}
      if(!strcmp(argv[j],"-debug"))
	{
	  DEBUG=1;
	}
      if(strstr(argv[j],"-port:"))
      {
	str_porta=strstr(argv[j],"-port:");
	str_porta=str_porta+6;
	tmp_porta=0;
	while(*str_porta!='\0')
	  {
	    tmp_porta=tmp_porta*10+(int)(str_porta[0]-'0');
	    str_porta++;
	  }
	if(DEBUG) printf("MYPORT:%d\n\n",tmp_porta);
	MYPORT=tmp_porta;
      }
    }
  

  serverSocket=socket(AF_INET,SOCK_STREAM,0);
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(MYPORT);
  serverAddr.sin_addr.s_addr=INADDR_ANY;
  memset(&(serverAddr.sin_zero),0,8);

  bind(serverSocket,(struct sockaddr*)&serverAddr,sizeof(struct sockaddr));

  time(&tempo);
  printf("%s",mytime(localtime(&tempo)));
  printf("\n\t\t(l:%d,d:%d) %s (%s): ready to send!! :)\n\n",logflag,DEBUG,argv[0],VERSION);

  listen(serverSocket,10);
  while(1)
    {
      clientAddrSize=sizeof(struct sockaddr_in);
      do
	{
	  sock=accept(serverSocket,(struct sockaddr*) &clientAddr,&clientAddrSize);
	}while ((sock==-1) && (errno==EINTR));
      if(sock==-1)
	{
	  printf("Bad accept\n");
	  exit(1);
	}
      entity=gethostbyaddr((char*) &clientAddr.sin_addr,sizeof(struct in_addr),AF_INET);

      if(DEBUG) printf("-------------------------\n");
      if(DEBUG) printf("Connection from %s\n",inet_ntoa((struct in_addr) clientAddr.sin_addr));

      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s -------------------------\n",mytime(localtime(&tempo)));
	}
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Connection from %s\n",mytime(localtime(&tempo)),inet_ntoa((struct in_addr) clientAddr.sin_addr));
	}
      i=recv(sock,recvBuffer,BUFSIZE,0);

      if(PDEBUG) printf("i:%d\n",i);

      if(i==-1) break;
      /*if(recvBuffer[i-1]!='\n') break;*/

      recvBuffer[i]='\0';

      if(DEBUG) printf("Received from client: \n*****\n%s\n*****\n",recvBuffer);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Received from client: \n*****\n%s\n*****\n",mytime(localtime(&tempo)),recvBuffer);
	  fflush(logfile);
	}
      totalReceived=0;


      if((!strcmp(nomefile(recvBuffer),"cmd:ls")||
	  !strcmp(nomefile(recvBuffer),"cmd%3Als"))||
	  !strcmp(nomefile(recvBuffer),"cmd_ls"))
	{
	  if(DEBUG) printf("Request: list\n");

	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Request: list\n",mytime(localtime(&tempo)));
	      fflush(logfile);
	    }
	  
	  childPID=fork();
	  if(childPID==0)
	    {
	      if(DEBUG) printf("mklstxt(PID:%d)\n",getpid());
	      execvp("mklstxt",NULL);
	      exit(0);
	    }

	  else 
	    {
	      if(DEBUG) printf("padre(PID:%d) aspetto....\n",getpid());
	      while(1)
		{
	          stop = waitpid((pid_t)childPID,&stato,WUNTRACED);
		  if(WIFEXITED(stato)!=0) break;
		}
	      stato=0;
	      if(DEBUG) printf("padre(PID:%d) ricomincio!\n",getpid());
	      read_file("GET /ls.tmp_txt",totalReceived,&sock);

	      childPID=fork();
	      if(childPID==0)
		{
		  if(DEBUG) printf("rmlstxt(PID:%d)\n",getpid());
		  execvp("rmlstxt",NULL);
		  exit(0);
		}
	      else
		{
		  if(DEBUG) printf("padre(PID:%d) aspetto....\n",getpid());
		  while(1)
		    {
		      stop = waitpid((pid_t)childPID,&stato,WUNTRACED);
		      if(WIFEXITED(stato)!=0) break;
		    }
		  stato=0;
		  if(DEBUG) printf("padre(PID:%d) ricomincio!\n",getpid());  
		}
	      close(sock);
	      if(DEBUG) printf("Connection closed by client.\n");
	    }
	} //inserire comandi????
      else
	{  
	if(shallIfork(nomefile(recvBuffer))) 
	{
	  if(DEBUG) printf("devo forkare, nome file:%s\n",nomefile(recvBuffer));

	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s devo forkare, nome file:%s\n",mytime(localtime(&tempo)),nomefile(recvBuffer));
	    }

	  childPID=fork();
	  if(childPID==0) 
	    {
	      if(DEBUG) printf("Parent: PID %d, Child: PID %d\n",getppid(),getpid());
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Parent: PID %d, Child: PID %d\n",mytime(localtime(&tempo)),getppid(),getpid());
		}

	      read_file(recvBuffer,totalReceived,&sock);
	      close(sock);
	      if(DEBUG) printf("Connection closed by client.\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      exit(0);
	    }
	  else
	    { 
	      close(sock);  
	      if(DEBUG) printf("Sending in background....\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Sending in background....\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      sa_dontcare.sa_handler=SIG_IGN;      /*per non lasciare troppi processi zombie*/
	      sa_dontcare.sa_flags=SA_NOCLDSTOP;   /*idem*/
	      sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/
	    }
	}
	else 
	  {
	    if(DEBUG) printf("non devo forkare, PID:%d\n",getpid());
	    if(logflag)
	      {
		time(&tempo);
		fprintf(logfile,"%s non devo forkare, PID:%d\n",mytime(localtime(&tempo)),getpid());
	      }
	    read_file(recvBuffer,totalReceived,&sock);
	    close(sock);
	    if(DEBUG) printf("Connection closed by client.\n");
	    if(logflag)
	      { 
		time(&tempo);
		fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		fflush(logfile);
	      }
	  }
	}
    }
  return 0;
}
